#!/bin/bash 
# TROTZ ALLER SORGFALT GEBE ICH KEINERLEI GARANTIEN 
# !BENUTZUNG AUF EIGENE GEFAHR!
### AUTHOR
# Author: Klaus Luettgens 
# Mail: linux@sualk.de; linux@kl-chs.de
# Web: www.kl-chs.de ; www.sualk.de ; www.kl-tools.de ;
# Copyright (c) 01-2006 by jd <Klaus Luettgens> 
# Distributed under the GPL version 2 
### BESCHREIBUNG
# iso2dir - Hängt iso9660-Images in ein Verzeichnis ein
# ist gedacht als Nautilus-Script
# (im Nautilus rechte Maustaste auf Image-Datei -> Scripts -> ISO2DIR)
### BENÖTIGT
# 2 Dateien: "ISO2DIR" und ".iso2dir.sh" (diese hier)
# gehören in den Ordner: "$HOME/.gnome2/nautilus-scripts/"
# beide Dateien müssen ausführbar sein ('chmod 755 DATEINAME' oder 
# 'rechte Maustaste -> Eigenschaften -> Zugriffsrechte -> Ausführen anhaken')
#
## Das Haupt-Verzeichnis, in welches die Images gemounted werden festlegen.
DIR2MOUNT="/media/CD_images"
## Funktion Einhängen:
FU_EINHAENGEN() {
# Prüfen und evtl. erstellen des Verzeichnisses, wo die Images eingehängt werden
if [ ! -d $DIR2MOUNT ]; then
	echo "# Einzuhängendes Verzeichnis existiert nicht"; sleep 1; echo 10
	mkdir $DIR2MOUNT
	chmod 755 $DIR2MOUNT
   echo "# ($DIR2MOUNT/)...wurde erstellt."; sleep 1; echo 20
fi
# Image in Unterverzeichnis einhängen und evtl. Fehler anzeigen
if [ ! -e "$1" ]; then
	echo "# ISO-Datei nicht gefunden. Abbruch."; sleep 1; echo 90
else
	if [ ! -d $DIR2MOUNT/$1 ]; then
		echo "# Erstelle Verzeichnis:"; sleep 1; echo 30
		mkdir $DIR2MOUNT/$1
		echo "# $DIR2MOUNT/$1/"; sleep 1; echo 40
		echo "# Hänge ISO ein ..."; sleep 1; echo 50
		mount -o loop -t iso9660 $1 $DIR2MOUNT/$1 2> $HOME/mountfehler.txt; 
		echo 60
		if [ `cat "$HOME/mountfehler.txt" | wc -c` -gt "0" ]
			then
			zenity --title "Fehler beim einhängen: (ISO2DIR)" --text-info --width=400 --height=400 --filename="$HOME/mountfehler.txt" & sleep 3
		fi
		rm -f $HOME/mountfehler.txt
		echo "# Wenn keine Fehler angezeigt wurden,"; sleep 1.5; echo 70
		echo "# ist das ISO erfolgreich eingehängt worden."; sleep 2; echo 80
		echo "# Der Inhalt befindet sich dann in"; sleep 1.5; echo 90
		echo "# $DIR2MOUNT/$1/"; echo 95
	else
		echo "# ISO in $DIR2MOUNT/$1/"; sleep 1; echo 40
		echo "# ist schon eingehängt (existiert bereits)."; sleep 1; echo 60
		echo "# Abbruch!"; sleep 1; echo 90
    fi
fi
}
## Funktion Aushängen:
FU_AUSHAENGEN() {
# Image aushängen evtl. Fehler anzeigen und Unterverzeichnis wieder löschen
if [ ! -d $DIR2MOUNT/$1 ]; then
	echo 50; echo "# $1 war nicht eingehängt";sleep 2
	echo 90; echo "# Abbruch!";sleep 1
else
	echo "# $1 wird ausgehängt!"; sleep 0.5; echo 10
	umount $DIR2MOUNT/$1 2> $HOME/mountfehler.txt; sleep 0.5; echo 25
	rmdir $DIR2MOUNT/$1 2> $HOME/mountfehler.txt; sleep 0.5; echo 50
		if [ `cat "$HOME/mountfehler.txt" | wc -c` -gt "0" ]
			then
			zenity --title "Fehler beim aushängen: (ISO2DIR)" --text-info --width=400 --height=400 --filename="$HOME/mountfehler.txt" & sleep 3;
		fi
	echo 75
	echo "# Wenn keine Fehler angezeigt wurden, ist"; sleep 1.5; echo 80
	rm -f $HOME/mountfehler.txt; echo 88
	echo "# $1 erfolgreich ausgehängt!"; echo 95
fi
}
###############################################################################
### Eigentlicher Scriptanfang
## Je nachdem ob image gemounted ist, Image einhängen oder aushängen
if [ ! -d $DIR2MOUNT/$1 ];
	then
	(FU_EINHAENGEN "$1"; echo 100) | zenity --progress --width=500 --title "ISO Einhängen"
	else
	(FU_AUSHAENGEN "$1"; echo 100) | zenity --progress --width=500 --title "ISO Aushängen"
fi
